/* ***********************************************************
 * This file was automatically generated on 2020-05-19.      *
 *                                                           *
 * Rust Bindings Version 2.0.15                              *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

//! Measures UV-A, UV-B and UV index.
//!
//! See also the documentation [here](https://www.tinkerforge.com/en/doc/Software/Bricklets/UVLightV2_Bricklet_Rust.html).
use crate::{
    byte_converter::*, converting_callback_receiver::ConvertingCallbackReceiver, converting_receiver::ConvertingReceiver, device::*,
    ip_connection::GetRequestSender,
};
pub enum UvLightV2BrickletFunction {
    GetUva,
    SetUvaCallbackConfiguration,
    GetUvaCallbackConfiguration,
    GetUvb,
    SetUvbCallbackConfiguration,
    GetUvbCallbackConfiguration,
    GetUvi,
    SetUviCallbackConfiguration,
    GetUviCallbackConfiguration,
    SetConfiguration,
    GetConfiguration,
    GetSpitfpErrorCount,
    SetBootloaderMode,
    GetBootloaderMode,
    SetWriteFirmwarePointer,
    WriteFirmware,
    SetStatusLedConfig,
    GetStatusLedConfig,
    GetChipTemperature,
    Reset,
    WriteUid,
    ReadUid,
    GetIdentity,
    CallbackUva,
    CallbackUvb,
    CallbackUvi,
}
impl From<UvLightV2BrickletFunction> for u8 {
    fn from(fun: UvLightV2BrickletFunction) -> Self {
        match fun {
            UvLightV2BrickletFunction::GetUva => 1,
            UvLightV2BrickletFunction::SetUvaCallbackConfiguration => 2,
            UvLightV2BrickletFunction::GetUvaCallbackConfiguration => 3,
            UvLightV2BrickletFunction::GetUvb => 5,
            UvLightV2BrickletFunction::SetUvbCallbackConfiguration => 6,
            UvLightV2BrickletFunction::GetUvbCallbackConfiguration => 7,
            UvLightV2BrickletFunction::GetUvi => 9,
            UvLightV2BrickletFunction::SetUviCallbackConfiguration => 10,
            UvLightV2BrickletFunction::GetUviCallbackConfiguration => 11,
            UvLightV2BrickletFunction::SetConfiguration => 13,
            UvLightV2BrickletFunction::GetConfiguration => 14,
            UvLightV2BrickletFunction::GetSpitfpErrorCount => 234,
            UvLightV2BrickletFunction::SetBootloaderMode => 235,
            UvLightV2BrickletFunction::GetBootloaderMode => 236,
            UvLightV2BrickletFunction::SetWriteFirmwarePointer => 237,
            UvLightV2BrickletFunction::WriteFirmware => 238,
            UvLightV2BrickletFunction::SetStatusLedConfig => 239,
            UvLightV2BrickletFunction::GetStatusLedConfig => 240,
            UvLightV2BrickletFunction::GetChipTemperature => 242,
            UvLightV2BrickletFunction::Reset => 243,
            UvLightV2BrickletFunction::WriteUid => 248,
            UvLightV2BrickletFunction::ReadUid => 249,
            UvLightV2BrickletFunction::GetIdentity => 255,
            UvLightV2BrickletFunction::CallbackUva => 4,
            UvLightV2BrickletFunction::CallbackUvb => 8,
            UvLightV2BrickletFunction::CallbackUvi => 12,
        }
    }
}
pub const UV_LIGHT_V2_BRICKLET_THRESHOLD_OPTION_OFF: char = 'x';
pub const UV_LIGHT_V2_BRICKLET_THRESHOLD_OPTION_OUTSIDE: char = 'o';
pub const UV_LIGHT_V2_BRICKLET_THRESHOLD_OPTION_INSIDE: char = 'i';
pub const UV_LIGHT_V2_BRICKLET_THRESHOLD_OPTION_SMALLER: char = '<';
pub const UV_LIGHT_V2_BRICKLET_THRESHOLD_OPTION_GREATER: char = '>';
pub const UV_LIGHT_V2_BRICKLET_INTEGRATION_TIME_50MS: u8 = 0;
pub const UV_LIGHT_V2_BRICKLET_INTEGRATION_TIME_100MS: u8 = 1;
pub const UV_LIGHT_V2_BRICKLET_INTEGRATION_TIME_200MS: u8 = 2;
pub const UV_LIGHT_V2_BRICKLET_INTEGRATION_TIME_400MS: u8 = 3;
pub const UV_LIGHT_V2_BRICKLET_INTEGRATION_TIME_800MS: u8 = 4;
pub const UV_LIGHT_V2_BRICKLET_BOOTLOADER_MODE_BOOTLOADER: u8 = 0;
pub const UV_LIGHT_V2_BRICKLET_BOOTLOADER_MODE_FIRMWARE: u8 = 1;
pub const UV_LIGHT_V2_BRICKLET_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT: u8 = 2;
pub const UV_LIGHT_V2_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT: u8 = 3;
pub const UV_LIGHT_V2_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT: u8 = 4;
pub const UV_LIGHT_V2_BRICKLET_BOOTLOADER_STATUS_OK: u8 = 0;
pub const UV_LIGHT_V2_BRICKLET_BOOTLOADER_STATUS_INVALID_MODE: u8 = 1;
pub const UV_LIGHT_V2_BRICKLET_BOOTLOADER_STATUS_NO_CHANGE: u8 = 2;
pub const UV_LIGHT_V2_BRICKLET_BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT: u8 = 3;
pub const UV_LIGHT_V2_BRICKLET_BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT: u8 = 4;
pub const UV_LIGHT_V2_BRICKLET_BOOTLOADER_STATUS_CRC_MISMATCH: u8 = 5;
pub const UV_LIGHT_V2_BRICKLET_STATUS_LED_CONFIG_OFF: u8 = 0;
pub const UV_LIGHT_V2_BRICKLET_STATUS_LED_CONFIG_ON: u8 = 1;
pub const UV_LIGHT_V2_BRICKLET_STATUS_LED_CONFIG_SHOW_HEARTBEAT: u8 = 2;
pub const UV_LIGHT_V2_BRICKLET_STATUS_LED_CONFIG_SHOW_STATUS: u8 = 3;

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct UvaCallbackConfiguration {
    pub period: u32,
    pub value_has_to_change: bool,
    pub option: char,
    pub min: i32,
    pub max: i32,
}
impl FromByteSlice for UvaCallbackConfiguration {
    fn bytes_expected() -> usize { 14 }
    fn from_le_byte_slice(bytes: &[u8]) -> UvaCallbackConfiguration {
        UvaCallbackConfiguration {
            period: <u32>::from_le_byte_slice(&bytes[0..4]),
            value_has_to_change: <bool>::from_le_byte_slice(&bytes[4..5]),
            option: <char>::from_le_byte_slice(&bytes[5..6]),
            min: <i32>::from_le_byte_slice(&bytes[6..10]),
            max: <i32>::from_le_byte_slice(&bytes[10..14]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct UvbCallbackConfiguration {
    pub period: u32,
    pub value_has_to_change: bool,
    pub option: char,
    pub min: i32,
    pub max: i32,
}
impl FromByteSlice for UvbCallbackConfiguration {
    fn bytes_expected() -> usize { 14 }
    fn from_le_byte_slice(bytes: &[u8]) -> UvbCallbackConfiguration {
        UvbCallbackConfiguration {
            period: <u32>::from_le_byte_slice(&bytes[0..4]),
            value_has_to_change: <bool>::from_le_byte_slice(&bytes[4..5]),
            option: <char>::from_le_byte_slice(&bytes[5..6]),
            min: <i32>::from_le_byte_slice(&bytes[6..10]),
            max: <i32>::from_le_byte_slice(&bytes[10..14]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct UviCallbackConfiguration {
    pub period: u32,
    pub value_has_to_change: bool,
    pub option: char,
    pub min: i32,
    pub max: i32,
}
impl FromByteSlice for UviCallbackConfiguration {
    fn bytes_expected() -> usize { 14 }
    fn from_le_byte_slice(bytes: &[u8]) -> UviCallbackConfiguration {
        UviCallbackConfiguration {
            period: <u32>::from_le_byte_slice(&bytes[0..4]),
            value_has_to_change: <bool>::from_le_byte_slice(&bytes[4..5]),
            option: <char>::from_le_byte_slice(&bytes[5..6]),
            min: <i32>::from_le_byte_slice(&bytes[6..10]),
            max: <i32>::from_le_byte_slice(&bytes[10..14]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct SpitfpErrorCount {
    pub error_count_ack_checksum: u32,
    pub error_count_message_checksum: u32,
    pub error_count_frame: u32,
    pub error_count_overflow: u32,
}
impl FromByteSlice for SpitfpErrorCount {
    fn bytes_expected() -> usize { 16 }
    fn from_le_byte_slice(bytes: &[u8]) -> SpitfpErrorCount {
        SpitfpErrorCount {
            error_count_ack_checksum: <u32>::from_le_byte_slice(&bytes[0..4]),
            error_count_message_checksum: <u32>::from_le_byte_slice(&bytes[4..8]),
            error_count_frame: <u32>::from_le_byte_slice(&bytes[8..12]),
            error_count_overflow: <u32>::from_le_byte_slice(&bytes[12..16]),
        }
    }
}

#[derive(Clone, Debug, Default, PartialEq, Eq, Hash)]
pub struct Identity {
    pub uid: String,
    pub connected_uid: String,
    pub position: char,
    pub hardware_version: [u8; 3],
    pub firmware_version: [u8; 3],
    pub device_identifier: u16,
}
impl FromByteSlice for Identity {
    fn bytes_expected() -> usize { 25 }
    fn from_le_byte_slice(bytes: &[u8]) -> Identity {
        Identity {
            uid: <String>::from_le_byte_slice(&bytes[0..8]),
            connected_uid: <String>::from_le_byte_slice(&bytes[8..16]),
            position: <char>::from_le_byte_slice(&bytes[16..17]),
            hardware_version: <[u8; 3]>::from_le_byte_slice(&bytes[17..20]),
            firmware_version: <[u8; 3]>::from_le_byte_slice(&bytes[20..23]),
            device_identifier: <u16>::from_le_byte_slice(&bytes[23..25]),
        }
    }
}

/// Measures UV-A, UV-B and UV index
#[derive(Clone)]
pub struct UvLightV2Bricklet {
    device: Device,
}
impl UvLightV2Bricklet {
    pub const DEVICE_IDENTIFIER: u16 = 2118;
    pub const DEVICE_DISPLAY_NAME: &'static str = "UV Light Bricklet 2.0";
    /// Creates an object with the unique device ID `uid`. This object can then be used after the IP Connection `ip_connection` is connected.
    pub fn new<T: GetRequestSender>(uid: &str, req_sender: T) -> UvLightV2Bricklet {
        let mut result = UvLightV2Bricklet { device: Device::new([2, 0, 0], uid, req_sender, 0) };
        result.device.response_expected[u8::from(UvLightV2BrickletFunction::GetUva) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(UvLightV2BrickletFunction::SetUvaCallbackConfiguration) as usize] =
            ResponseExpectedFlag::True;
        result.device.response_expected[u8::from(UvLightV2BrickletFunction::GetUvaCallbackConfiguration) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(UvLightV2BrickletFunction::GetUvb) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(UvLightV2BrickletFunction::SetUvbCallbackConfiguration) as usize] =
            ResponseExpectedFlag::True;
        result.device.response_expected[u8::from(UvLightV2BrickletFunction::GetUvbCallbackConfiguration) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(UvLightV2BrickletFunction::GetUvi) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(UvLightV2BrickletFunction::SetUviCallbackConfiguration) as usize] =
            ResponseExpectedFlag::True;
        result.device.response_expected[u8::from(UvLightV2BrickletFunction::GetUviCallbackConfiguration) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(UvLightV2BrickletFunction::SetConfiguration) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(UvLightV2BrickletFunction::GetConfiguration) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(UvLightV2BrickletFunction::GetSpitfpErrorCount) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(UvLightV2BrickletFunction::SetBootloaderMode) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(UvLightV2BrickletFunction::GetBootloaderMode) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(UvLightV2BrickletFunction::SetWriteFirmwarePointer) as usize] =
            ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(UvLightV2BrickletFunction::WriteFirmware) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(UvLightV2BrickletFunction::SetStatusLedConfig) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(UvLightV2BrickletFunction::GetStatusLedConfig) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(UvLightV2BrickletFunction::GetChipTemperature) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(UvLightV2BrickletFunction::Reset) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(UvLightV2BrickletFunction::WriteUid) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(UvLightV2BrickletFunction::ReadUid) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(UvLightV2BrickletFunction::GetIdentity) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result
    }

    /// Returns the response expected flag for the function specified by the function ID parameter.
    /// It is true if the function is expected to send a response, false otherwise.
    ///
    /// For getter functions this is enabled by default and cannot be disabled, because those
    /// functions will always send a response. For callback configuration functions it is enabled
    /// by default too, but can be disabled by [`set_response_expected`](crate::uv_light_v2_bricklet::UvLightV2Bricklet::set_response_expected).
    /// For setter functions it is disabled by default and can be enabled.
    ///
    /// Enabling the response expected flag for a setter function allows to detect timeouts
    /// and other error conditions calls of this setter as well. The device will then send a response
    /// for this purpose. If this flag is disabled for a setter function then no response is sent
    /// and errors are silently ignored, because they cannot be detected.
    ///
    /// See [`set_response_expected`](crate::uv_light_v2_bricklet::UvLightV2Bricklet::set_response_expected) for the list of function ID constants available for this function.
    pub fn get_response_expected(&mut self, fun: UvLightV2BrickletFunction) -> Result<bool, GetResponseExpectedError> {
        self.device.get_response_expected(u8::from(fun))
    }

    /// Changes the response expected flag of the function specified by the function ID parameter.
    /// This flag can only be changed for setter (default value: false) and callback configuration
    /// functions (default value: true). For getter functions it is always enabled.
    ///
    /// Enabling the response expected flag for a setter function allows to detect timeouts and
    /// other error conditions calls of this setter as well. The device will then send a response
    /// for this purpose. If this flag is disabled for a setter function then no response is sent
    /// and errors are silently ignored, because they cannot be detected.
    pub fn set_response_expected(
        &mut self,
        fun: UvLightV2BrickletFunction,
        response_expected: bool,
    ) -> Result<(), SetResponseExpectedError> {
        self.device.set_response_expected(u8::from(fun), response_expected)
    }

    /// Changes the response expected flag for all setter and callback configuration functions of this device at once.
    pub fn set_response_expected_all(&mut self, response_expected: bool) { self.device.set_response_expected_all(response_expected) }

    /// Returns the version of the API definition (major, minor, revision) implemented by this API bindings.
    /// This is neither the release version of this API bindings nor does it tell you anything about the represented Brick or Bricklet.
    pub fn get_api_version(&self) -> [u8; 3] { self.device.api_version }

    /// This receiver is triggered periodically according to the configuration set by
    /// [`set_uva_callback_configuration`].
    ///
    /// The parameter is the same as [`get_uva`].
    ///
    /// [`get_uva`]: #method.get_uva
    /// [`set_uva_callback_configuration`]: #method.set_uva_callback_configuration
    pub fn get_uva_callback_receiver(&self) -> ConvertingCallbackReceiver<i32> {
        self.device.get_callback_receiver(u8::from(UvLightV2BrickletFunction::CallbackUva))
    }

    /// This receiver is triggered periodically according to the configuration set by
    /// [`set_uvb_callback_configuration`].
    ///
    /// The parameter is the same as [`get_uvb`].
    pub fn get_uvb_callback_receiver(&self) -> ConvertingCallbackReceiver<i32> {
        self.device.get_callback_receiver(u8::from(UvLightV2BrickletFunction::CallbackUvb))
    }

    /// This receiver is triggered periodically according to the configuration set by
    /// [`set_uvi_callback_configuration`].
    ///
    /// The parameter is the same as [`get_uvi`].
    pub fn get_uvi_callback_receiver(&self) -> ConvertingCallbackReceiver<i32> {
        self.device.get_callback_receiver(u8::from(UvLightV2BrickletFunction::CallbackUvi))
    }

    /// Returns the UVA intensity of the sensor.
    /// The sensor has not weighted the intensity with the erythemal
    /// action spectrum to get the skin-affecting irradiation. Therefore, you cannot
    /// just divide the value by 250 to get the UVA index. To get the UV index use
    /// [`get_uvi`].
    ///
    /// If the sensor is saturated, then -1 is returned, see [`set_configuration`].
    ///
    /// If you want to get the intensity periodically, it is recommended to use the
    /// [`get_uva_callback_receiver`] receiver and set the period with
    /// [`set_uva_callback_configuration`].
    ///
    ///
    /// If you want to get the value periodically, it is recommended to use the
    /// [`get_uva_callback_receiver`] receiver. You can set the receiver configuration
    /// with [`set_uva_callback_configuration`].
    pub fn get_uva(&self) -> ConvertingReceiver<i32> {
        let payload = vec![0; 0];

        self.device.get(u8::from(UvLightV2BrickletFunction::GetUva), payload)
    }

    /// The period is the period with which the [`get_uva_callback_receiver`] receiver is triggered
    /// periodically. A value of 0 turns the receiver off.
    ///
    /// If the `value has to change`-parameter is set to true, the receiver is only
    /// triggered after the value has changed. If the value didn't change
    /// within the period, the receiver is triggered immediately on change.
    ///
    /// If it is set to false, the receiver is continuously triggered with the period,
    /// independent of the value.
    ///
    /// It is furthermore possible to constrain the receiver with thresholds.
    ///
    /// The `option`-parameter together with min/max sets a threshold for the [`get_uva_callback_receiver`] receiver.
    ///
    /// The following options are possible:
    ///
    ///  Option| Description
    ///  --- | ---
    ///  'x'|    Threshold is turned off
    ///  'o'|    Threshold is triggered when the value is *outside* the min and max values
    ///  'i'|    Threshold is triggered when the value is *inside* or equal to the min and max values
    ///  '<'|    Threshold is triggered when the value is smaller than the min value (max is ignored)
    ///  '>'|    Threshold is triggered when the value is greater than the min value (max is ignored)
    ///
    /// If the option is set to 'x' (threshold turned off) the receiver is triggered with the fixed period.
    ///
    /// Associated constants:
    /// * UV_LIGHT_V2_BRICKLET_THRESHOLD_OPTION_OFF
    ///	* UV_LIGHT_V2_BRICKLET_THRESHOLD_OPTION_OUTSIDE
    ///	* UV_LIGHT_V2_BRICKLET_THRESHOLD_OPTION_INSIDE
    ///	* UV_LIGHT_V2_BRICKLET_THRESHOLD_OPTION_SMALLER
    ///	* UV_LIGHT_V2_BRICKLET_THRESHOLD_OPTION_GREATER
    pub fn set_uva_callback_configuration(
        &self,
        period: u32,
        value_has_to_change: bool,
        option: char,
        min: i32,
        max: i32,
    ) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 14];
        payload[0..4].copy_from_slice(&<u32>::to_le_byte_vec(period));
        payload[4..5].copy_from_slice(&<bool>::to_le_byte_vec(value_has_to_change));
        payload[5..6].copy_from_slice(&<char>::to_le_byte_vec(option));
        payload[6..10].copy_from_slice(&<i32>::to_le_byte_vec(min));
        payload[10..14].copy_from_slice(&<i32>::to_le_byte_vec(max));

        self.device.set(u8::from(UvLightV2BrickletFunction::SetUvaCallbackConfiguration), payload)
    }

    /// Returns the receiver configuration as set by [`set_uva_callback_configuration`].
    ///
    /// Associated constants:
    /// * UV_LIGHT_V2_BRICKLET_THRESHOLD_OPTION_OFF
    ///	* UV_LIGHT_V2_BRICKLET_THRESHOLD_OPTION_OUTSIDE
    ///	* UV_LIGHT_V2_BRICKLET_THRESHOLD_OPTION_INSIDE
    ///	* UV_LIGHT_V2_BRICKLET_THRESHOLD_OPTION_SMALLER
    ///	* UV_LIGHT_V2_BRICKLET_THRESHOLD_OPTION_GREATER
    pub fn get_uva_callback_configuration(&self) -> ConvertingReceiver<UvaCallbackConfiguration> {
        let payload = vec![0; 0];

        self.device.get(u8::from(UvLightV2BrickletFunction::GetUvaCallbackConfiguration), payload)
    }

    /// Returns the UVB intensity of the sensor.
    /// The sensor has not weighted the intensity with the erythemal
    /// action spectrum to get the skin-affecting irradiation. Therefore, you cannot
    /// just divide the value by 250 to get the UVB index. To get the UV index use
    /// [`get_uvi`].
    ///
    /// If the sensor is saturated, then -1 is returned, see [`set_configuration`].
    ///
    /// If you want to get the intensity periodically, it is recommended to use the
    /// [`get_uvb_callback_receiver`] receiver and set the period with
    /// [`set_uvb_callback_configuration`].
    ///
    ///
    /// If you want to get the value periodically, it is recommended to use the
    /// [`get_uvb_callback_receiver`] receiver. You can set the receiver configuration
    /// with [`set_uvb_callback_configuration`].
    pub fn get_uvb(&self) -> ConvertingReceiver<i32> {
        let payload = vec![0; 0];

        self.device.get(u8::from(UvLightV2BrickletFunction::GetUvb), payload)
    }

    /// The period is the period with which the [`get_uvb_callback_receiver`] receiver is triggered
    /// periodically. A value of 0 turns the receiver off.
    ///
    /// If the `value has to change`-parameter is set to true, the receiver is only
    /// triggered after the value has changed. If the value didn't change
    /// within the period, the receiver is triggered immediately on change.
    ///
    /// If it is set to false, the receiver is continuously triggered with the period,
    /// independent of the value.
    ///
    /// It is furthermore possible to constrain the receiver with thresholds.
    ///
    /// The `option`-parameter together with min/max sets a threshold for the [`get_uvb_callback_receiver`] receiver.
    ///
    /// The following options are possible:
    ///
    ///  Option| Description
    ///  --- | ---
    ///  'x'|    Threshold is turned off
    ///  'o'|    Threshold is triggered when the value is *outside* the min and max values
    ///  'i'|    Threshold is triggered when the value is *inside* or equal to the min and max values
    ///  '<'|    Threshold is triggered when the value is smaller than the min value (max is ignored)
    ///  '>'|    Threshold is triggered when the value is greater than the min value (max is ignored)
    ///
    /// If the option is set to 'x' (threshold turned off) the receiver is triggered with the fixed period.
    ///
    /// Associated constants:
    /// * UV_LIGHT_V2_BRICKLET_THRESHOLD_OPTION_OFF
    ///	* UV_LIGHT_V2_BRICKLET_THRESHOLD_OPTION_OUTSIDE
    ///	* UV_LIGHT_V2_BRICKLET_THRESHOLD_OPTION_INSIDE
    ///	* UV_LIGHT_V2_BRICKLET_THRESHOLD_OPTION_SMALLER
    ///	* UV_LIGHT_V2_BRICKLET_THRESHOLD_OPTION_GREATER
    pub fn set_uvb_callback_configuration(
        &self,
        period: u32,
        value_has_to_change: bool,
        option: char,
        min: i32,
        max: i32,
    ) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 14];
        payload[0..4].copy_from_slice(&<u32>::to_le_byte_vec(period));
        payload[4..5].copy_from_slice(&<bool>::to_le_byte_vec(value_has_to_change));
        payload[5..6].copy_from_slice(&<char>::to_le_byte_vec(option));
        payload[6..10].copy_from_slice(&<i32>::to_le_byte_vec(min));
        payload[10..14].copy_from_slice(&<i32>::to_le_byte_vec(max));

        self.device.set(u8::from(UvLightV2BrickletFunction::SetUvbCallbackConfiguration), payload)
    }

    /// Returns the receiver configuration as set by [`set_uvb_callback_configuration`].
    ///
    /// Associated constants:
    /// * UV_LIGHT_V2_BRICKLET_THRESHOLD_OPTION_OFF
    ///	* UV_LIGHT_V2_BRICKLET_THRESHOLD_OPTION_OUTSIDE
    ///	* UV_LIGHT_V2_BRICKLET_THRESHOLD_OPTION_INSIDE
    ///	* UV_LIGHT_V2_BRICKLET_THRESHOLD_OPTION_SMALLER
    ///	* UV_LIGHT_V2_BRICKLET_THRESHOLD_OPTION_GREATER
    pub fn get_uvb_callback_configuration(&self) -> ConvertingReceiver<UvbCallbackConfiguration> {
        let payload = vec![0; 0];

        self.device.get(u8::from(UvLightV2BrickletFunction::GetUvbCallbackConfiguration), payload)
    }

    /// Returns the UV index of the sensor, the index is given in 1/10.
    ///
    /// If the sensor is saturated, then -1 is returned, see [`set_configuration`].
    ///
    /// If you want to get the intensity periodically, it is recommended to use the
    /// [`get_uvi_callback_receiver`] receiver and set the period with
    /// [`set_uvi_callback_configuration`].
    ///
    ///
    /// If you want to get the value periodically, it is recommended to use the
    /// [`get_uvi_callback_receiver`] receiver. You can set the receiver configuration
    /// with [`set_uvi_callback_configuration`].
    pub fn get_uvi(&self) -> ConvertingReceiver<i32> {
        let payload = vec![0; 0];

        self.device.get(u8::from(UvLightV2BrickletFunction::GetUvi), payload)
    }

    /// The period is the period with which the [`get_uvi_callback_receiver`] receiver is triggered
    /// periodically. A value of 0 turns the receiver off.
    ///
    /// If the `value has to change`-parameter is set to true, the receiver is only
    /// triggered after the value has changed. If the value didn't change
    /// within the period, the receiver is triggered immediately on change.
    ///
    /// If it is set to false, the receiver is continuously triggered with the period,
    /// independent of the value.
    ///
    /// It is furthermore possible to constrain the receiver with thresholds.
    ///
    /// The `option`-parameter together with min/max sets a threshold for the [`get_uvi_callback_receiver`] receiver.
    ///
    /// The following options are possible:
    ///
    ///  Option| Description
    ///  --- | ---
    ///  'x'|    Threshold is turned off
    ///  'o'|    Threshold is triggered when the value is *outside* the min and max values
    ///  'i'|    Threshold is triggered when the value is *inside* or equal to the min and max values
    ///  '<'|    Threshold is triggered when the value is smaller than the min value (max is ignored)
    ///  '>'|    Threshold is triggered when the value is greater than the min value (max is ignored)
    ///
    /// If the option is set to 'x' (threshold turned off) the receiver is triggered with the fixed period.
    ///
    /// Associated constants:
    /// * UV_LIGHT_V2_BRICKLET_THRESHOLD_OPTION_OFF
    ///	* UV_LIGHT_V2_BRICKLET_THRESHOLD_OPTION_OUTSIDE
    ///	* UV_LIGHT_V2_BRICKLET_THRESHOLD_OPTION_INSIDE
    ///	* UV_LIGHT_V2_BRICKLET_THRESHOLD_OPTION_SMALLER
    ///	* UV_LIGHT_V2_BRICKLET_THRESHOLD_OPTION_GREATER
    pub fn set_uvi_callback_configuration(
        &self,
        period: u32,
        value_has_to_change: bool,
        option: char,
        min: i32,
        max: i32,
    ) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 14];
        payload[0..4].copy_from_slice(&<u32>::to_le_byte_vec(period));
        payload[4..5].copy_from_slice(&<bool>::to_le_byte_vec(value_has_to_change));
        payload[5..6].copy_from_slice(&<char>::to_le_byte_vec(option));
        payload[6..10].copy_from_slice(&<i32>::to_le_byte_vec(min));
        payload[10..14].copy_from_slice(&<i32>::to_le_byte_vec(max));

        self.device.set(u8::from(UvLightV2BrickletFunction::SetUviCallbackConfiguration), payload)
    }

    /// Returns the receiver configuration as set by [`set_uvi_callback_configuration`].
    ///
    /// Associated constants:
    /// * UV_LIGHT_V2_BRICKLET_THRESHOLD_OPTION_OFF
    ///	* UV_LIGHT_V2_BRICKLET_THRESHOLD_OPTION_OUTSIDE
    ///	* UV_LIGHT_V2_BRICKLET_THRESHOLD_OPTION_INSIDE
    ///	* UV_LIGHT_V2_BRICKLET_THRESHOLD_OPTION_SMALLER
    ///	* UV_LIGHT_V2_BRICKLET_THRESHOLD_OPTION_GREATER
    pub fn get_uvi_callback_configuration(&self) -> ConvertingReceiver<UviCallbackConfiguration> {
        let payload = vec![0; 0];

        self.device.get(u8::from(UvLightV2BrickletFunction::GetUviCallbackConfiguration), payload)
    }

    /// Sets the configuration of the sensor. The integration time can be configured
    /// between 50 and 800 ms. With a shorter integration time the sensor reading updates
    /// more often but contains more noise. With a longer integration the sensor reading
    /// contains less noise but updates less often.
    ///
    /// With a longer integration time (especially 800 ms) and a higher UV intensity the
    /// sensor can be saturated. If this happens the UVA/UVB/UVI readings are all -1.
    /// In this case you need to choose a shorter integration time.
    ///
    /// Associated constants:
    /// * UV_LIGHT_V2_BRICKLET_INTEGRATION_TIME_50MS
    ///	* UV_LIGHT_V2_BRICKLET_INTEGRATION_TIME_100MS
    ///	* UV_LIGHT_V2_BRICKLET_INTEGRATION_TIME_200MS
    ///	* UV_LIGHT_V2_BRICKLET_INTEGRATION_TIME_400MS
    ///	* UV_LIGHT_V2_BRICKLET_INTEGRATION_TIME_800MS
    pub fn set_configuration(&self, integration_time: u8) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 1];
        payload[0..1].copy_from_slice(&<u8>::to_le_byte_vec(integration_time));

        self.device.set(u8::from(UvLightV2BrickletFunction::SetConfiguration), payload)
    }

    /// Returns the configuration as set by [`set_configuration`].
    ///
    /// Associated constants:
    /// * UV_LIGHT_V2_BRICKLET_INTEGRATION_TIME_50MS
    ///	* UV_LIGHT_V2_BRICKLET_INTEGRATION_TIME_100MS
    ///	* UV_LIGHT_V2_BRICKLET_INTEGRATION_TIME_200MS
    ///	* UV_LIGHT_V2_BRICKLET_INTEGRATION_TIME_400MS
    ///	* UV_LIGHT_V2_BRICKLET_INTEGRATION_TIME_800MS
    pub fn get_configuration(&self) -> ConvertingReceiver<u8> {
        let payload = vec![0; 0];

        self.device.get(u8::from(UvLightV2BrickletFunction::GetConfiguration), payload)
    }

    /// Returns the error count for the communication between Brick and Bricklet.
    ///
    /// The errors are divided into
    ///
    /// * ACK checksum errors,
    /// * message checksum errors,
    /// * framing errors and
    /// * overflow errors.
    ///
    /// The errors counts are for errors that occur on the Bricklet side. All
    /// Bricks have a similar function that returns the errors on the Brick side.
    pub fn get_spitfp_error_count(&self) -> ConvertingReceiver<SpitfpErrorCount> {
        let payload = vec![0; 0];

        self.device.get(u8::from(UvLightV2BrickletFunction::GetSpitfpErrorCount), payload)
    }

    /// Sets the bootloader mode and returns the status after the requested
    /// mode change was instigated.
    ///
    /// You can change from bootloader mode to firmware mode and vice versa. A change
    /// from bootloader mode to firmware mode will only take place if the entry function,
    /// device identifier and CRC are present and correct.
    ///
    /// This function is used by Brick Viewer during flashing. It should not be
    /// necessary to call it in a normal user program.
    ///
    /// Associated constants:
    /// * UV_LIGHT_V2_BRICKLET_BOOTLOADER_MODE_BOOTLOADER
    ///	* UV_LIGHT_V2_BRICKLET_BOOTLOADER_MODE_FIRMWARE
    ///	* UV_LIGHT_V2_BRICKLET_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT
    ///	* UV_LIGHT_V2_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT
    ///	* UV_LIGHT_V2_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT
    ///	* UV_LIGHT_V2_BRICKLET_BOOTLOADER_STATUS_OK
    ///	* UV_LIGHT_V2_BRICKLET_BOOTLOADER_STATUS_INVALID_MODE
    ///	* UV_LIGHT_V2_BRICKLET_BOOTLOADER_STATUS_NO_CHANGE
    ///	* UV_LIGHT_V2_BRICKLET_BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT
    ///	* UV_LIGHT_V2_BRICKLET_BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT
    ///	* UV_LIGHT_V2_BRICKLET_BOOTLOADER_STATUS_CRC_MISMATCH
    pub fn set_bootloader_mode(&self, mode: u8) -> ConvertingReceiver<u8> {
        let mut payload = vec![0; 1];
        payload[0..1].copy_from_slice(&<u8>::to_le_byte_vec(mode));

        self.device.get(u8::from(UvLightV2BrickletFunction::SetBootloaderMode), payload)
    }

    /// Returns the current bootloader mode, see [`set_bootloader_mode`].
    ///
    /// Associated constants:
    /// * UV_LIGHT_V2_BRICKLET_BOOTLOADER_MODE_BOOTLOADER
    ///	* UV_LIGHT_V2_BRICKLET_BOOTLOADER_MODE_FIRMWARE
    ///	* UV_LIGHT_V2_BRICKLET_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT
    ///	* UV_LIGHT_V2_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT
    ///	* UV_LIGHT_V2_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT
    pub fn get_bootloader_mode(&self) -> ConvertingReceiver<u8> {
        let payload = vec![0; 0];

        self.device.get(u8::from(UvLightV2BrickletFunction::GetBootloaderMode), payload)
    }

    /// Sets the firmware pointer for [`write_firmware`]. The pointer has
    /// to be increased by chunks of size 64. The data is written to flash
    /// every 4 chunks (which equals to one page of size 256).
    ///
    /// This function is used by Brick Viewer during flashing. It should not be
    /// necessary to call it in a normal user program.
    pub fn set_write_firmware_pointer(&self, pointer: u32) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 4];
        payload[0..4].copy_from_slice(&<u32>::to_le_byte_vec(pointer));

        self.device.set(u8::from(UvLightV2BrickletFunction::SetWriteFirmwarePointer), payload)
    }

    /// Writes 64 Bytes of firmware at the position as written by
    /// [`set_write_firmware_pointer`] before. The firmware is written
    /// to flash every 4 chunks.
    ///
    /// You can only write firmware in bootloader mode.
    ///
    /// This function is used by Brick Viewer during flashing. It should not be
    /// necessary to call it in a normal user program.
    pub fn write_firmware(&self, data: [u8; 64]) -> ConvertingReceiver<u8> {
        let mut payload = vec![0; 64];
        payload[0..64].copy_from_slice(&<[u8; 64]>::to_le_byte_vec(data));

        self.device.get(u8::from(UvLightV2BrickletFunction::WriteFirmware), payload)
    }

    /// Sets the status LED configuration. By default the LED shows
    /// communication traffic between Brick and Bricklet, it flickers once
    /// for every 10 received data packets.
    ///
    /// You can also turn the LED permanently on/off or show a heartbeat.
    ///
    /// If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    ///
    /// Associated constants:
    /// * UV_LIGHT_V2_BRICKLET_STATUS_LED_CONFIG_OFF
    ///	* UV_LIGHT_V2_BRICKLET_STATUS_LED_CONFIG_ON
    ///	* UV_LIGHT_V2_BRICKLET_STATUS_LED_CONFIG_SHOW_HEARTBEAT
    ///	* UV_LIGHT_V2_BRICKLET_STATUS_LED_CONFIG_SHOW_STATUS
    pub fn set_status_led_config(&self, config: u8) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 1];
        payload[0..1].copy_from_slice(&<u8>::to_le_byte_vec(config));

        self.device.set(u8::from(UvLightV2BrickletFunction::SetStatusLedConfig), payload)
    }

    /// Returns the configuration as set by [`set_status_led_config`]
    ///
    /// Associated constants:
    /// * UV_LIGHT_V2_BRICKLET_STATUS_LED_CONFIG_OFF
    ///	* UV_LIGHT_V2_BRICKLET_STATUS_LED_CONFIG_ON
    ///	* UV_LIGHT_V2_BRICKLET_STATUS_LED_CONFIG_SHOW_HEARTBEAT
    ///	* UV_LIGHT_V2_BRICKLET_STATUS_LED_CONFIG_SHOW_STATUS
    pub fn get_status_led_config(&self) -> ConvertingReceiver<u8> {
        let payload = vec![0; 0];

        self.device.get(u8::from(UvLightV2BrickletFunction::GetStatusLedConfig), payload)
    }

    /// Returns the temperature as measured inside the microcontroller. The
    /// value returned is not the ambient temperature!
    ///
    /// The temperature is only proportional to the real temperature and it has bad
    /// accuracy. Practically it is only useful as an indicator for
    /// temperature changes.
    pub fn get_chip_temperature(&self) -> ConvertingReceiver<i16> {
        let payload = vec![0; 0];

        self.device.get(u8::from(UvLightV2BrickletFunction::GetChipTemperature), payload)
    }

    /// Calling this function will reset the Bricklet. All configurations
    /// will be lost.
    ///
    /// After a reset you have to create new device objects,
    /// calling functions on the existing ones will result in
    /// undefined behavior!
    pub fn reset(&self) -> ConvertingReceiver<()> {
        let payload = vec![0; 0];

        self.device.set(u8::from(UvLightV2BrickletFunction::Reset), payload)
    }

    /// Writes a new UID into flash. If you want to set a new UID
    /// you have to decode the Base58 encoded UID string into an
    /// integer first.
    ///
    /// We recommend that you use Brick Viewer to change the UID.
    pub fn write_uid(&self, uid: u32) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 4];
        payload[0..4].copy_from_slice(&<u32>::to_le_byte_vec(uid));

        self.device.set(u8::from(UvLightV2BrickletFunction::WriteUid), payload)
    }

    /// Returns the current UID as an integer. Encode as
    /// Base58 to get the usual string version.
    pub fn read_uid(&self) -> ConvertingReceiver<u32> {
        let payload = vec![0; 0];

        self.device.get(u8::from(UvLightV2BrickletFunction::ReadUid), payload)
    }

    /// Returns the UID, the UID where the Bricklet is connected to,
    /// the position, the hardware and firmware version as well as the
    /// device identifier.
    ///
    /// The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    /// The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
    /// connected to an [Isolator Bricklet](isolator_bricklet) is always as
    /// position 'z'.
    ///
    /// The device identifier numbers can be found [here](device_identifier).
    /// |device_identifier_constant|
    pub fn get_identity(&self) -> ConvertingReceiver<Identity> {
        let payload = vec![0; 0];

        self.device.get(u8::from(UvLightV2BrickletFunction::GetIdentity), payload)
    }
}
